var __rest = (this && this.__rest) || function (s, e) {
    var t = {};
    for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p) && e.indexOf(p) < 0)
        t[p] = s[p];
    if (s != null && typeof Object.getOwnPropertySymbols === "function")
        for (var i = 0, p = Object.getOwnPropertySymbols(s); i < p.length; i++) {
            if (e.indexOf(p[i]) < 0 && Object.prototype.propertyIsEnumerable.call(s, p[i]))
                t[p[i]] = s[p[i]];
        }
    return t;
};
import ConfigProvider from '../config-provider';
import PropTypes from 'prop-types';
import React, { Component } from 'react';
import cls from 'classnames';
import { Tab as NextTab } from '@alifd/next';
import { getTheme } from '../utils/getTheme';
import { omitProps } from '../utils/object';
class Tab extends Component {
    render() {
        const _a = this.props, { prefix = 'next-', className, shape = 'pure', size } = _a, otherProps = __rest(_a, ["prefix", "className", "shape", "size"]);
        const theme = getTheme(this.context, this.props);
        if (shape === 'pure' || shape === 'text') {
            if (size === 'large') {
                return (React.createElement(NextTab, Object.assign({}, omitProps(otherProps, ['size']), { shape: shape, className: cls(className, {
                        [`${prefix}large`]: size === 'large',
                        [`${prefix}white`]: theme === 'white',
                        [`${prefix}grey`]: theme === 'grey',
                    }) })));
            }
            return (React.createElement(NextTab, Object.assign({}, otherProps, { shape: shape, size: 'small', className: cls(className, {
                    [`${prefix}white`]: theme === 'white',
                    [`${prefix}grey`]: theme === 'grey',
                }) })));
        }
        if (shape === 'wrapped') {
            const _b = this.props, { prefix = 'next-', className } = _b, otherProps = __rest(_b, ["prefix", "className"]);
            if (size === 'large') {
                return (React.createElement(NextTab, Object.assign({}, omitProps(otherProps, ['size']), { className: cls(className, {
                        [`${prefix}large`]: size === 'large',
                        [`${prefix}white`]: theme === 'white',
                        [`${prefix}grey`]: theme === 'grey',
                    }) })));
            }
            return (React.createElement(NextTab, Object.assign({}, otherProps, { size: 'medium', className: cls(className, {
                    [`${prefix}white`]: theme === 'white',
                    [`${prefix}grey`]: theme === 'grey',
                }) })));
        }
        return (React.createElement(NextTab, Object.assign({}, otherProps, { className: cls(className, {
                [`${prefix}white`]: theme === 'white',
                [`${prefix}grey`]: theme === 'grey',
            }) })));
    }
}
Tab.Item = NextTab.Item;
Tab.contextTypes = {
    theme: PropTypes.string,
};
export default ConfigProvider.config(Tab);
